
-- ssupa jupms
-- -Pacola

freeslot(
	"S_ASNICK_SJUMPSTND",
	"S_ASNICK_SJUMP",
	"sfx_sjprp",
	"sfx_sjhld",
	"sfx_sjrls",
	"SPR_SNEX",
	"S_ASNICK_SJFX"
)

states[S_ASNICK_SJUMPSTND] = {
	sprite = SPR_PLAY,
	frame = SPR2_BNCE|FF_ANIMATE,
	tics = -1,
	nextstate = S_ASNICK_SJUMPSTND,
	var1 = C,
	var2 = 2
}

states[S_ASNICK_SJUMP] = {
	sprite = SPR_PLAY,
	frame = SPR2_TWIN|FF_ANIMATE,
	tics = -1,
	nextstate = S_ASNICK_SJUMP,
	var1 = C,
	var2 = 2
}

sfxinfo[sfx_sjprp].caption = "Super Jump Prep."
sfxinfo[sfx_sjhld].caption = "Super Jump Hold"
sfxinfo[sfx_sjrls].caption = "Super Jump Release"

states[S_ASNICK_SJFX] = {
	sprite = SPR_SNEX,
	frame = A|FF_ANIMATE,
	tics = (G+1)*2,
	nextstate = S_NULL,
	var1 = G,
	var2 = 2
}

local function canSJ(p)
	if P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
	or p.asnicktaunting
	or p.altsnickdived
	or p.asnickgp.active
	or p.asnickfireass
	or ((p.pflags & PF_STASIS) and not p.altsnicksj.sjumped)
	or p.exiting
		return false
	end
	return true
end

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "altsnick" return end
	
	if p.altsnicksj == nil
		p.altsnicksj = {
			enabled = false,
			sjumped = false
		}
		p.altsnicksjl = 0
	end
	
	if (p.cmd.buttons & BT_SPIN)
		p.altsnickspin = $+1
	else
		p.altsnickspin = 0
	end
	
	if p.altsnicksjcancel
	and P_IsObjectOnGround(p.mo)
	or p.altsnicksjcancel == nil
		p.altsnicksjcancel = false
	end
	
	local m = p.asnickmach
	local sj = p.altsnicksj
	if not p.altsnickrobot
	and not sj.enabled
	and canSJ(p)
	and not p.asnickroll.active
	and p.altsnicksjl < 3
	and (m and m.num >= 3)
	and (p.cmd.buttons & BT_CUSTOM1)
		--p.altsnicksjcancel = false
		if not P_IsObjectOnGround(p.mo)
			local add = (not G_RingSlingerGametype() and 1) or 69420 -- what? i need to make sure you cant do it
			p.altsnicksjl = $+add
		end
		m.time = 0
		S_StartSound(p.mo, sfx_sjprp)
		sj.sjumped = false
		sj.enabled = true
	end
	
	if sj.enabled
		p.pflags = $1|PF_JUMPSTASIS
		if not (p.cmd.buttons & BT_CUSTOM1)
		and not sj.sjumped
		and p.mo.ceilingz-p.mo.floorz >= 48*p.mo.scale
			S_StopSoundByID(p.mo, sfx_sjhld)
			S_StartSound(p.mo, sfx_sjrls)
			sj.sjumped = true
			local fx = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
			fx.scale = p.mo.scale
			fx.state = S_ASNICK_SJFX
		end
		if not canSJ(p)
			sj.enabled = false
		end
		
		if sj.sjumped
			p.powers[pw_strong] = $1|STR_CEILING|STR_ATTACK|STR_ANIM
			if p.mo.state ~= S_ASNICK_SJUMP
				p.mo.state = S_ASNICK_SJUMP
			end
			
			local cz = p.mo.ceilingz
			if (p.mo.eflags & MFE_VERTICALFLIP)
				cz = p.mo.floorz
			end
			if (p.mo.z+p.mo.height >= p.mo.ceilingz and not (p.mo.eflags & MFE_VERTICALFLIP))
			or (p.mo.z-p.mo.height <= p.mo.floorz and (p.mo.eflags & MFE_VERTICALFLIP))
				sj.enabled = false
				p.mo.momz = 0
				S_StartSound(p.mo, sfx_sgphit)
				p.mo.state = S_ASNICK_CEILBONK
				p.asnickceilbonk = true
				return
			end
			
			p.pflags = $1|PF_STASIS
			P_SetObjectMomZ(p.mo, 35*p.mo.scale)
			if p.speed > FU/5
				local speed = max(min(FU/3, FixedDiv(p.speed, p.normalspeed)), FU)
				P_Thrust(p.mo, R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy), -speed)
			elseif p.speed > 0
			and p.speed < FU/5
				P_InstaThrust(p.mo, 0, 0)
			end
			if p.altsnickspin == 1
				sj.enabled = false
				p.mo.momz = 0
				m.time = 3*TICRATE
				local snum = min(m.time*(FU/(32*TICRATE)), FU)
				local sease = ease.linear(snum, skins[p.mo.skin].normalspeed, skins[p.mo.skin].normalspeed*4)
				P_InstaThrust(p.mo, p.mo.angle, FixedMul(sease, p.mo.scale))
				p.mo.state = S_PLAY_RUN
				p.altsnicksjcancel = true
				p.altsnickspin = 2
				return
			end
		else
			p.altsnicksjcancel = false
			if p.speed > 10*p.mo.scale
			and P_IsObjectOnGround(p.mo)
				P_InstaThrust(p.mo, R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy), 10*p.mo.scale-p.mo.scale/2)
			end
			if p.mo.state ~= S_ASNICK_SJUMPSTND
				p.mo.state = S_ASNICK_SJUMPSTND
			end
			
			if not S_SoundPlaying(p.mo, sfx_sjhld)
			and not S_SoundPlaying(p.mo, sfx_sjprp)
				S_StartSound(p.mo, sfx_sjhld)
			end
		end
	elseif P_IsObjectOnGround(p.mo)
		p.altsnicksjl = 0
	elseif S_SoundPlaying(p.mo, sfx_sjhld)
		S_StopSoundByID(p.mo, sfx_sjhld)
	elseif sj.sjumped
		sj.sjumped = false
	end
end)