
-- taunt from pizza tower
-- and also parry from rizz power (piza towe)
-- -Pacola :D

freeslot(
	"S_ASNICK_TAUNT",
	"S_ASNICK_PARRY1",
	"S_ASNICK_PARRY2",
	"SPR_SNTN",
	"S_ASNICK_TAUNTFX",
	"SPR_SNPR",
	"S_ASNICK_PARRYFX",
	"sfx_taunt",
	"sfx_parry"
)

states[S_ASNICK_TAUNT] = {
	sprite = SPR_PLAY,
	frame = SPR2_SWIM,
	tics = -1,
	nextstate = S_PLAY_FALL
}

states[S_ASNICK_PARRY1] = {
	sprite = SPR_PLAY,
	frame = SPR2_FIRE,
	tics = (M+1)*2,
	action = A_RoboAnim,
	nextstate = S_PLAY_STND,
	var1 = A,
	var2 = 2
}

RoboVars[S_ASNICK_PARRY1] = {
	var3 = A,
	lframe = M
}

states[S_ASNICK_PARRY2] = {
	sprite = SPR_PLAY,
	frame = SPR2_FIRE|FF_ANIMATE,
	tics = (N+1)*2,
	action = A_RoboAnim,
	nextstate = S_PLAY_STND,
	var1 = N,
	var2 = 2
}

RoboVars[S_ASNICK_PARRY2] = {
	var3 = N,
	lframe = Z+1
}

states[S_ASNICK_TAUNTFX] = {
	sprite = SPR_SNTN,
	frame = A|FF_ANIMATE,
	tics = (I+1)*2,
	nextstate = S_NULL,
	var1 = I,
	var2 = 2
}

states[S_ASNICK_PARRYFX] = {
	sprite = SPR_SNPR,
	frame = A|FF_ANIMATE,
	tics = (F+1)*2,
	nextstate = S_NULL,
	var1 = F,
	var2 = 2
}

sfxinfo[sfx_taunt].caption = "Taunt"
sfxinfo[sfx_parry].caption = "I'm not gonna sugarcoat it."

local function canTaunt(p)
	if P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
	or (p.pflags & PF_STASIS)
	or p.exiting
	or p.asnickwallrun
	or p.asnickceilbonk
	or p.asnickparry
	or p.asnicktdelay
	or p.asnickpeelout
	or p.altsnickrobot
	or p.asnickfireass
	or p.altsnicksj.enabled
	or p.asnickgp.active
	or p.asnickroll.active
	or p.mo.state == S_ASNICK_HITWALL
	or p.mo.state == S_ASNICK_BONK
		return false
	end
	return true
end

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "altsnick" return end
	
	if (p.cmd.buttons & BT_TOSSFLAG)
		p.asnickc2held = $+1
	else
		p.asnickc2held = 0
	end
	
	if p.asnickc2held == 1
	and canTaunt(p)
	and not p.asnicktaunting
		S_StartSound(p.mo, sfx_taunt)
		p.asnicktaunt = {
			mom = {
				x = p.mo.momx,
				y = p.mo.momy,
				z = p.mo.momz
			},
			state = p.mo.state,
			frame = p.mo.frame,
			time = 0
		}
		p.mo.state = S_ASNICK_TAUNT
		p.mo.frame = P_RandomRange(A, skins[p.mo.skin].sprites[SPR2_SWIM].numframes-1)
		p.asnicktaunt.tframe = p.mo.frame
		p.asnicktaunting = true
	end
	
	if p.asnicktaunting
		if not p.asnicktfx
			p.mo.spriteyoffset = $+15*FU
			p.asnicktfx = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
			local fx = p.asnicktfx
			fx.target = p.mo
			fx.state = S_ASNICK_TAUNTFX
			fx.flags = $1|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
			fx.flags2 = p.mo.flags2
			fx.eflags = p.mo.eflags
			fx.dispoffset = -1
		else
			local fx = p.asnicktfx
			fx.flags2 = p.mo.flags2
			fx.eflags = p.mo.eflags
		end
		local t = p.asnicktaunt
		if not p.asnickoldradius
			p.asnickoldradius = p.mo.radius
		end
		if not canTaunt(p)
		and not (p.pflags & PF_STASIS)
			--p.asnicktaunting = false
			t.time = 18
			--return
		end
		p.mo.radius = p.asnickoldradius*2
		p.mo.flags = $1|MF_NOCLIPHEIGHT
		p.pflags = $1|PF_FULLSTASIS
		if not (p.mo.state >= S_ASNICK_PARRY1 and p.mo.state <= S_ASNICK_PARRY2)
			p.mo.momx = 0
			p.mo.momy = 0
			p.mo.momz = 0
		end
		t.time = $+1
		if t.time >= 18
			p.asnicktdelay = TICRATE/4
			p.mo.radius = p.asnickoldradius
			p.mo.flags = $ & ~MF_NOCLIPHEIGHT
			p.asnickoldradius = nil
			p.mo.momx = t.mom.x
			p.mo.momy = t.mom.y
			p.mo.momz = t.mom.z
			P_MovePlayer(p)
			p.mo.state = t.state
			p.mo.frame = t.frame
			p.asnicktaunting = false
		elseif p.mo.state ~= S_ASNICK_TAUNT
		and not p.asnickparry
			p.mo.state = S_ASNICK_TAUNT
			p.mo.frame = t.tframe
		end
	elseif p.asnicktfx
		p.mo.spriteyoffset = $-15*FU
		if (p.asnicktfx and p.asnicktfx.valid)
			P_RemoveMobj(p.asnicktfx)
		end
		p.asnicktfx = nil
	elseif p.asnickoldradius
		p.mo.radius = p.asnickoldradius
		p.mo.flags = $ & ~MF_NOCLIPHEIGHT
		p.asnickoldradius = nil
	end
	
	if p.asnicktdelay
		p.asnicktdelay = $-1
	end
	
	if p.asnickparry
		--print("you have the parry variable active")
		local pt = p.asnickparryt
		p.pflags = $1|PF_FULLSTASIS
		if (p.mo.state >= S_ASNICK_PARRY1 and p.mo.state <= S_ASNICK_PARRY2)
			pt.frame = p.mo.frame
			pt.anim_dur = p.mo.anim_duration
			pt.tics = p.mo.tics
			pt.state = p.mo.state
		elseif pt
		and pt.tics > 1
			p.mo.state = pt.state
			p.mo.frame = pt.frame
			p.mo.tics = pt.tics
			p.mo.anim_duration = pt.anim_dur
		elseif pt
		and pt.tics <= 1
			p.asnickparry = false
		end
	end
end)

addHook("ShouldDamage", function(pmo, inf, _, _, dmg)
	local p = pmo.player
	
	if not p.asnicktaunting
	or not (inf and inf.valid)
	or (dmg & DMG_DEATHMASK) return end
	
	if (p.asnicktfx and p.asnicktfx.valid)
		P_RemoveMobj(p.asnicktfx)
	end
	p.asnicktaunting = false
	--p.asnicktdelay = TICRATE/3
	S_StopSoundByID(p.mo, sfx_taunt)
	S_StartSound(p.mo, sfx_parry)
	pmo.state = _G["S_ASNICK_PARRY"+P_RandomRange(1, 2)]
	local fx = P_SpawnMobj(pmo.x, pmo.y, pmo.z, MT_THOK)
	fx.state = S_ASNICK_PARRYFX
	--fx.target = pmo
	fx.dispoffset = pmo.dispoffset+1
	fx.spriteyoffset = -25*FU
	if (inf.flags & MF_MISSILE)
		inf.target = pmo
		inf.momx = -$
		inf.momy = -$
		inf.momz = -$
	elseif (inf.flags & MF_SHOOTABLE)
		P_DamageMobj(inf, pmo)
	end
	if p.powers[pw_flashing] < TICRATE+TICRATE/2
		p.powers[pw_flashing] = TICRATE+TICRATE/2
	end
	p.drawangle = R_PointToAngle2(pmo.x, pmo.y, inf.x, inf.y)
	P_InstaThrust(pmo, p.drawangle, -5*FU)
	P_MovePlayer(p)
	P_SetObjectMomZ(pmo, 4*FU)
	p.asnickparryt = {
		frame = pmo.frame,
		anim_dur = pmo.anim_duration,
		tics = pmo.tics,
		state = pmo.state
	}
	p.asnickparry = true
	return false
end, MT_PLAYER)