
-- makes the sign become snick's one
-- either when you spawn as snick in sp
-- or you hit it in mp
-- also by pacola

freeslot(
	"SPR_SNSG",
	"S_ASNICK_SIGNIDLE",
	"S_ASNICK_SIGNSPIN",
	"S_ASNICK_SIGNSNICK"
)

states[S_ASNICK_SIGNIDLE] = {
	sprite = SPR_SNSG,
	frame = A,
	tics = -1,
	nextstate = S_ASNICK_SIGNIDLE
}

states[S_ASNICK_SIGNSPIN] = {
	sprite = SPR_SNSG,
	frame = A|FF_ANIMATE,
	tics = (Q+1)*3,
	nextstate = S_ASNICK_SIGNSNICK,
	var1 = P,
	var2 = 3
}

states[S_ASNICK_SIGNSNICK] = {
	sprite = SPR_SNSG,
	frame = R,
	tics = -1,
	nextstate = S_ASNICK_SIGNSNICK
}

addHook("MobjThinker", function(mo)
	if not multiplayer
		local p = consoleplayer
		
		if not (p.mo and p.mo.valid)
		or p.mo.skin ~= "altsnick" return end
		
		if mo.state == mo.info.spawnstate
			mo.state = S_ASNICK_SIGNIDLE
		end
	
		if (mo.tracer and mo.tracer.valid)
		and (mo.tracer.tracer and mo.tracer.tracer.valid)
			P_RemoveMobj(mo.tracer.tracer)
			P_RemoveMobj(mo.tracer)
		end
		
		if mo.state == S_ASNICK_SIGNIDLE
		and ((p.pflags & PF_FINISHED) or p.exiting)
			S_StartSound(mo, sfx_lvpass)
			mo.state = S_ASNICK_SIGNSPIN
			mo.color = p.mo.color
		end
	else
		if (mo.tracer and mo.tracer.valid)
		and (mo.tracer.tracer and mo.tracer.tracer.valid)
		and mo.state == S_SIGNSPIN1
		and (mo.target and mo.target.valid)
		and mo.target.skin == "altsnick"
			P_RemoveMobj(mo.tracer.tracer)
			P_RemoveMobj(mo.tracer)
			mo.momz = -$
			mo.state = S_ASNICK_SIGNSPIN
			mo.color = mo.target.color
		end
	end
end, MT_SIGN)

-- i decided to also throw the win pose code here
-- so uhhh hi
-- note: this one is also made by pacola

freeslot("S_ASNICK_WIN")

states[S_ASNICK_WIN] = {
	sprite = SPR_PLAY,
	frame = SPR2_DRWN|FF_ANIMATE,
	tics = -1,
	nextstate = S_ASNICK_WIN,
	var1 = E,
	var2 = 5
}

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "altsnick" return end
	
	p.powers[pw_underwater] = 0
	p.powers[pw_spacetime] = 0
	
	if p.altsnickrobot return end
	
	if p.exiting--((p.pflags & PF_FINISHED) or p.exiting)
	and p.mo.state ~= S_ASNICK_WIN
	and p.speed < FU
		p.mo.state = S_ASNICK_WIN
	end
	
	if p.mo.state == S_ASNICK_WIN
	and p.mo.frame == D|FF_ANIMATE
		p.mo.frame = D
	end
end)

local function collide(m, m2)
	if not (m2.player and m2.player.valid)
	or m2.skin ~= "altsnick" return end
	
	return false
end

addHook("MobjCollide", collide, MT_EXTRALARGEBUBBLE)
addHook("MobjMoveCollide", collide, MT_EXTRALARGEBUBBLE)